
  int I2C_DiceCommand(uint8_t address) {

    // Memory
    int dice = 0;

    // Call Slave Addrees 
    Wire.beginTransmission(address); // or 0x20

    // Send Command 1 -> Roll A Dice
    Wire.write(0x01);

    // Stop Transmition
    Wire.endTransmission();

    // Request 1 byte from slave -> Contains A Number 1 to 6
    Wire.requestFrom(0x10, 1);

    // If Data Received
    if(Wire.available()) {

      // Read The Data
      dice = Wire.read();

    }

    // Return The Value To Master
    return dice

  }

  void I2C_PushData(uint8_t address, _player &pl1, _player &pl2) {
    
    // Slave Address
    Wire.beginTransmission(address);

    // Command Number - Push Data
    Wire.write(0x02);

    // Player One Data
    Wire.write(pl1.position.x);
    Wire.write(pl1.position.y); 
    Wire.write(pl1.color.r); 
    Wire.write(pl1.color.g); 
    Wire.write(pl1.color.b); 
    Wire.write(pl1.color.i); 
    Wire.write(pl1.health);

    // Player Two Data
    Wire.write(pl1.position.x);
    Wire.write(pl1.position.y); 
    Wire.write(pl1.color.r); 
    Wire.write(pl1.color.g); 
    Wire.write(pl1.color.b); 
    Wire.write(pl1.color.i); 
    Wire.write(pl1.health);
    
    // Stop Transmition
    Wire.endTransmission();

  }

  void I2C_Permission(uint8_t address) {

    // Card Color
    _color color;

    // Direction
    uint8_t Direction;

    Wire.beginTransmission(address);
    Wire.write(0x03); // permission to play command
    Wire.endTransmission();

    // Master waits for slave to send data
    Wire.requestFrom(0x10, 4); // expecting 2 bytes: card color (R, G, B), direction (one byte)

    // Receive Bytes 
    if(Wire.available()) {
      color.r = Wire.read();
      color.g = Wire.read();
      color.b = Wire.read();
      Direction = Wire.read();
    }

  }