
  // I2C scanner function
  void scanI2CBus(TwoWire &wire, const char* busName) {

    byte error, address;
    int nDevices = 0;
    Serial.print("Scanning I2C bus: ");
    Serial.println(busName);
    for(address = 1; address < 127; address++) {
      wire.beginTransmission(address);
      error = wire.endTransmission();
      if (error == 0) {
        Serial.print("I2C device found at address 0x");
        if (address < 16) Serial.print("0");
        Serial.print(address, HEX);
        Serial.println("  !");
        nDevices++;
      } else if (error == 4) {
        Serial.print("Unknown error at address 0x");
        if (address < 16) Serial.print("0");
        Serial.println(address, HEX);
      }
    }
    if (nDevices == 0)
      Serial.println("No I2C devices found\n");
    else
      Serial.println("done\n");
    
  }

//================================================================
//  
//================================================================

  String readJoystick() {

    // const int X_PIN = A0;
    // const int Y_PIN = A1;
    int xVal = analogRead(X_PIN);
    int yVal = analogRead(Y_PIN);

    // Deadzone centers and ranges (after increasing by 50)
    const int X_DEADZONE_MIN = 1975;
    const int X_DEADZONE_MAX = 2065;
    const int Y_DEADZONE_MIN = 1875;
    const int Y_DEADZONE_MAX = 1965;

    // Deadzone centers (can be calculated as (min+max)/2)
    const int X_CENTER = (X_DEADZONE_MIN + X_DEADZONE_MAX) / 2; // 2020
    const int Y_CENTER = (Y_DEADZONE_MIN + Y_DEADZONE_MAX) / 2; // 1920

    bool xInDeadzone = (xVal >= X_DEADZONE_MIN && xVal <= X_DEADZONE_MAX);
    bool yInDeadzone = (yVal >= Y_DEADZONE_MIN && yVal <= Y_DEADZONE_MAX);

    if (xInDeadzone && yInDeadzone) return "center";

    // Calculate how far each axis is from its deadzone center
    int xDist = abs(xVal - X_CENTER);
    int yDist = abs(yVal - Y_CENTER);

    // If both axes are outside their deadzones, choose the one with the greater movement
    if (!xInDeadzone && !yInDeadzone) {
      if (xDist > yDist) {
        if (xVal < X_CENTER) return "left";
        else return "right";
      } else {
        if (yVal < Y_CENTER) return "up";
        else return "down";
      }
    }
    // If only one axis is outside, return its direction
    else if (!yInDeadzone) {
      if (yVal < Y_CENTER) return "up";
      else return "down";
    }
    else if (!xInDeadzone) {
      if (xVal < X_CENTER) return "left";
      else return "right";
    }

    return "center";

  }

//================================================================
//  
//================================================================

  int analogReadAVG(uint8_t pin, uint8_t times) {

    int value;

    for(int i=0; i<times; i++) {
      
    }

  }