#include <Adafruit_DotStar.h>

#define DATAPIN    10   // Change to your data pin
#define CLOCKPIN   9   // Change to your clock pin
#define NUMPIXELS  64  // 8x8 matrix

Adafruit_DotStar matrix(NUMPIXELS, DATAPIN, CLOCKPIN, DOTSTAR_BGR);

// Function to set a single dot (x, y) to a color (r, g, b)
void map_setDot(int x, int y, byte r, byte g, byte b, byte brightness) {
  if (x < 0 || x > 7 || y < 0 || y > 7) return; // Out of bounds
  int index = x + y * 8; // Convert (x,y) to strip index

  // Scale the color by brightness (0–255)
  uint32_t color = matrix.Color(
    (uint8_t)(r * brightness / 255),
    (uint8_t)(g * brightness / 255),
    (uint8_t)(b * brightness / 255)
  );
  matrix.setPixelColor(index, color);
}

void map_begin() {
  matrix.begin();
  matrix.clear();
  matrix.show();
}

void map_show() {
  matrix.show();
}