  #include <Wire.h>

  // Custom I2C pins for ESP32-S3
  #define I2C_SDA_PIN 5
  #define I2C_SCL_PIN 4
  #define SLAVE_ADDR  0x10  // Use 0x20 for the second slave

  uint8_t receivedValue = 0;

  void setup() {
    Serial.begin(115200);
    Wire.setPins(I2C_SDA_PIN, I2C_SCL_PIN);
    Wire.begin(SLAVE_ADDR);
    Wire.onReceive(receiveEvent);
    Wire.onRequest(void (*)())
    Serial.print("Slave ready at address ");
    Serial.println(SLAVE_ADDR, HEX);
  }

  void loop() {
    // Nothing to do here; all logic is in callbacks
  }

  void receiveEvent(int numBytes) {

    // Serial.println("Number Of Bytes " + String(numBytes));
    uint8_t data[numBytes];

    // Serial.print  ("Received Value  ");
    for(int i=0; i<numBytes; i++) {
      data[i] = Wire.read();
      // Serial.print(data[i], HEX);
      // Serial.print(" ");
    }
    // Serial.println();

    // The Command Information
    uint8_t command = data[0];

    // Role Selection Based On Command
    switch(command) {

      case 0x01: // Dice Roll
              Serial.println("Command -> Dice Roll");
              receivedValue = 0x01;
              // Print Message On OLED Saying Roll The Dice
              // Send Back Dice Number
              Wire.write(Serial.readString().toInt());
              break;

      case 0x02: // Update
              Serial.println("Command -> Update Joystic");
              receivedValue = 0x02;
              // The Rest Of The Data Fills The DotMatrix & Health Bars
              break;

      case 0x03: // Permision - Request Data
              Serial.println("Command -> Permission");
              receivedValue = 0x03;
              // Read Movement From Joystic & When Button Is Pressed Send Joystic Data Back To Master
              // Send New Updated Data To Master
              break;

      case 0x04: // Deny
              Serial.println("Command -> Deny");
              receivedValue = 0x04;
              // Dont Allow Joystic Movments
              break;

    }

  }
