  #include <Wire.h>
  #include <FastLED.h>
  #include <Adafruit_SSD1306.h>
  #include <Adafruit_DotStarMatrix.h>
  #include <Adafruit_DotStar.h>
  #include <SPI.h>

// ============ PIN DEFINITIONS (ESP32-S3 Super Mini) ============

  #define JOY_X_PIN       A1      // Example: GP2, adjust to your wiring
  #define JOY_Y_PIN       A2      // Example: GP3, adjust to your wiring
  #define JOY_BTN_PIN     3       // Example: GP8, adjust to your wiring

  #define SLAVE_ADDR      0x10    // Use 0x10 for the second slave
  #define PUBLIC_I2C_SDA  5       // Example: GP9, SDA for OLED/APDS
  #define PUBLIC_I2C_SCL  4       // Example: GP10, SCL for OLED/APDS

  #define LOCAL_I2C_SDA   12      // Example: GP9, SDA for OLED/APDS
  #define LOCAL_I2C_SCL   11      // Example: GP10, SCL for OLED/APDS

  #define NUM_LEDS        16
  #define LED_DATA_PIN    8       // Example: GP11, adjust to your wiring

  #define DOTSTAR_WIDTH   8
  #define DOTSTAR_HEIGHT  8
  #define DOTSTAR_DATA    10      // Example: GP12, adjust to your wiring
  #define DOTSTAR_CLK     9       // Example: GP13, adjust to your wiring

  #define ONBOARD_RGB_LED 48      // Onboard WS2812 RGB LED on GP48

// ============ DEVICE OBJECTS =============

  Adafruit_SSD1306 display(128, 64, &Wire, -1);
  CRGB leds[NUM_LEDS];

  Adafruit_DotStarMatrix dotstar = Adafruit_DotStarMatrix(
    DOTSTAR_WIDTH, DOTSTAR_HEIGHT, DOTSTAR_DATA, DOTSTAR_CLK,
    DS_MATRIX_TOP + DS_MATRIX_LEFT + DS_MATRIX_ROWS + DS_MATRIX_PROGRESSIVE,
    DOTSTAR_BRG
  );