  #include <Wire.h>

  // Custom I2C pins for ESP32-S3
  #define I2C_SDA_PIN 5
  #define I2C_SCL_PIN 4
  #define SLAVE_ADDR  0x10  // Use 0x20 for the second slave

  uint8_t receivedValue = 0;

  void setup() {
    Serial.begin(115200);
    Wire.setPins(I2C_SDA_PIN, I2C_SCL_PIN);
    Wire.begin(SLAVE_ADDR);
    Wire.onReceive(receiveEvent);
    Serial.print("Slave ready at address 0x10");
  }

  void loop() {
    // Nothing to do here; all logic is in callbacks
  }

  void receiveEvent(int numBytes) {
    if (Wire.available()) {
      receivedValue = Wire.read();
      Serial.print("Received value: ");
      Serial.println(receivedValue);
    }
  }
